1#!/bin/bash
2
3#
4# Copyright (C) 2012 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10#      http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
18
19#
20# Generate all files we have templates for:
21#   docs.html
22#   ../src/camera_metadata_tag_info.c
23#   ../src/camera_metadata_tags.h
24#   ../../../../cts/tests/tests/hardware/src/android/hardware/camera2/cts/CameraCharacteristicsTest.java
25#   ../../../../cts/tests/tests/hardware/src/android/hardware/camera2/cts/CameraCaptureResultTest.java
26#   ../../../../frameworks/base/core/java/android/hardware/camera2/CameraCharacteristics.java
27#   ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureRequest.java
28#   ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureResult.java
29
30if [[ -z $ANDROID_BUILD_TOP ]]; then
31    echo "Please source build/envsetup.sh before running script" >& 2
32    exit 1
33fi
34
35thisdir=$(cd "$(dirname "$0")"; pwd)
36fwkdir="$ANDROID_BUILD_TOP/frameworks/base/core/java/android/hardware/camera2/"
37ctsdir="$ANDROID_BUILD_TOP/cts/tests/tests/hardware/src/android/hardware/camera2/cts"
38outdir="$ANDROID_PRODUCT_OUT/obj/ETC/system-media-camera-docs_intermediates"
39out_files=()
40
41function relpath() {
42    python -c "import os.path; print os.path.relpath('$1', '$PWD')"
43}
44
45# Generates a file. Appends to $out_files array as a side effect.
46function gen_file() {
47    local in=$thisdir/$1
48    local out=$thisdir/$2
49
50    gen_file_abs "$in" "$out"
51    return $?
52}
53
54function gen_file_abs() {
55    local in="$1"
56    local out="$2"
57    local intermediates="$3"
58
59    python $thisdir/metadata_parser_xml.py $thisdir/metadata_properties.xml $in $out
60
61    local succ=$?
62
63    if [[ $succ -eq 0 ]]
64    then
65        echo "OK: Generated $(relpath "$out")"
66        if [[ "$intermediates" != "no" ]]; then
67          out_files+=$'\n'" $out"
68        fi
69    else
70        echo "FAIL: Errors while generating $(relpath "$out")" >& 2
71    fi
72
73    return $succ
74}
75
76# Print a list of git repository paths which were affected after file generation
77function affected_git_directories() {
78    local input_files=($@)
79    local git_directories=()
80
81    for file in "${input_files[@]}"; do
82        local dir_path="$(dirname "$file")"
83        echo "Trying to cd into $dir_path" >& /dev/null
84        # Absolute path to the git repository root of that file
85        local git_path="$(cd "$dir_path";
86                          git rev-parse --show-toplevel 2> /dev/null)"
87        if [[ $? -eq 0 ]]; then
88            # Both staged and unstaged changes
89            local diff_result="$(cd "$dir_path";
90                                 git status --porcelain | egrep -c -v '^[?][?]')"
91            echo "Diff result was $diff_result" >& /dev/null
92            echo "Diff result was $diff_result" >& /dev/null
93            if [[ $diff_result -eq 0 ]]; then
94                echo "No changes in ${git_path}" >& /dev/null
95            else
96                echo "There are changes in ${git_path}" >& /dev/null
97                git_directories+=("$git_path")
98            fi
99        fi
100    done
101
102    # print as result the unique list of git directories affected
103    printf %s\\n "${git_directories[@]}" | sort | uniq
104}
105
106# Insert a file into the middle of another, starting at the line containing the
107# start delim and ending on the end delim, both of which are replaced
108function insert_file() {
109    local src_part="$1"
110    local dst_file="$2"
111    local start_delim="/*@O~"
112    local end_delim="~O@*/"
113
114    local start_line="$(grep -n -F "${start_delim}" "${dst_file}" | cut -d: -f1)"
115    local end_line="$(grep -n -F "${end_delim}" "${dst_file}" | cut -d: -f1)"
116
117    # Adjust cutoff points to use start/end line from inserted file
118    (( start_line-- ))
119    (( end_line++ ))
120
121    # Do some basic sanity checks
122
123    if [[ -z "$start_line" ]]; then
124       echo "No starting delimiter found in ${dst_file}" >& 2
125       echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
126       return 1
127    fi
128
129    if [[ -z "$end_line" ]]; then
130       echo "No ending delimiter found in ${dst_file}" >& 2
131       echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
132       return 1
133    fi
134
135    if [[ "$start_line" -ge "$end_line" ]]; then
136       echo "Starting delim later than ending delim: $start_line vs $end_line" >& 2
137       echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
138       return 1
139    fi
140
141    local tmp_name=$(mktemp -t XXXXXXXX)
142
143    # Compose the three parts of the final file together
144
145    head -n "$start_line" "${dst_file}" > "${tmp_name}"
146    cat "${src_part}" >> "${tmp_name}"
147    tail -n "+${end_line}" "${dst_file}" >> "${tmp_name}"
148
149    # And replace the destination file with the new version
150
151    mv "${tmp_name}" "${dst_file}"
152    echo "OK: Inserted $(relpath "$src_part") into $(relpath "$dst_file")"
153    out_files+=$'\n'" $dst_file"
154}
155
156$thisdir/metadata-check-dependencies || exit 1
157$thisdir/metadata-validate $thisdir/metadata_properties.xml || exit 1
158$thisdir/metadata-parser-sanity-check || exit 1
159
160# Generate HTML properties documentation
161gen_file html.mako docs.html || exit 1
162
163# Generate C API headers and implementation
164gen_file camera_metadata_tag_info.mako ../src/camera_metadata_tag_info.c || exit 1
165gen_file camera_metadata_tags.mako ../include/system/camera_metadata_tags.h || exit 1
166
167# Generate Java API definitions
168mkdir -p "${outdir}"
169gen_file_abs CameraMetadataEnums.mako "$outdir/CameraMetadataEnums.java.part" no || exit 1
170gen_file_abs CameraCharacteristicsKeys.mako "$outdir/CameraCharacteristicsKeys.java.part" no || exit 1
171gen_file_abs CaptureRequestKeys.mako "$outdir/CaptureRequestKeys.java.part" no || exit 1
172gen_file_abs CaptureResultKeys.mako "$outdir/CaptureResultKeys.java.part" no || exit 1
173gen_file_abs CameraCaptureResultTest.mako "$outdir/CameraCaptureResultTest.java.part" no || exit 1
174
175insert_file "$outdir/CameraMetadataEnums.java.part" "$fwkdir/CameraMetadata.java" || exit 1
176insert_file "$outdir/CameraCharacteristicsKeys.java.part" "$fwkdir/CameraCharacteristics.java" || exit 1
177insert_file "$outdir/CaptureRequestKeys.java.part" "$fwkdir/CaptureRequest.java" || exit 1
178insert_file "$outdir/CaptureResultKeys.java.part" "$fwkdir/CaptureResult.java" || exit 1
179
180# Generate CTS tests
181gen_file_abs CameraCharacteristicsTest.mako "$ctsdir/CameraCharacteristicsTest.java" || exit 1
182insert_file "$outdir/CameraCaptureResultTest.java.part" "$ctsdir/CameraCaptureResultTest.java" || exit 1
183
184echo ""
185echo "===================================================="
186echo "Successfully generated all metadata source files"
187echo "===================================================="
188echo ""
189
190echo "****************************************************"
191echo "The following git repositories need to be committed:"
192echo "****************************************************"
193echo ""
194affected_git_directories "${out_files[@]}"
195echo ""
196
197exit 0
198